SystemOrganization addCategory: #'Rizel-Roassal-Views'!
SystemOrganization addCategory: #'Rizel-Roassal-Views-Tests'!

TestCase subclass: #RzVisualizer1DTest
	instanceVariableNames: 'window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Roassal-Views-Tests'!

!RzVisualizer1DTest methodsFor: 'testing' stamp: ''!
tearDown
	window
		ifNotNilDo: [:t1 | t1 delete]! !

!RzVisualizer1DTest methodsFor: 'testing' stamp: ''!
testBarWidth
	window := RzVisualizer1D new values: #(10 20 30 40 10 );
				 barWidth: 20;
				 visualize! !

!RzVisualizer1DTest methodsFor: 'testing' stamp: ''!
testBasic
	window := RzVisualizer1D new values: #(10 20 30 40 10 );
				 visualize! !

!RzVisualizer1DTest methodsFor: 'testing' stamp: ''!
testBasic2
	window := RzVisualizer1D new values: #(10 67 120 1230 1250 );
				 visualize! !

!RzVisualizer1DTest methodsFor: 'testing' stamp: ''!
testGap
	window := RzVisualizer1D new values: #(10 20 30 40 10 );
				 gap: 40;
				 visualize! !

!RzVisualizer1DTest methodsFor: 'testing' stamp: ''!
testHeight
	window := RzVisualizer1D new values: #(10 20 30 40 10 );
				 height: 300;
				 visualize! !

!RzVisualizer1DTest methodsFor: 'testing' stamp: ''!
testLabel
	window := RzVisualizer1D new values: #(10 20 30 40 10 );
				
				label: [:t1 | 'x'];
				 visualize! !

!RzVisualizer1DTest methodsFor: 'testing' stamp: ''!
testOwner
	| t1 |
	t1 := RzVisualizer1D owner: 3.
	window := t1 values: #(10 20 30 40 10 );
				 padding: 100;
				 visualize.
	self assert: t1 owner = 3! !

!RzVisualizer1DTest methodsFor: 'testing' stamp: ''!
testPadding
	window := RzVisualizer1D new values: #(10 20 30 40 10 );
				 padding: 100;
				 visualize! !

TestCase subclass: #RzVisualizer2DTest
	instanceVariableNames: 'resultSet xs ys window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Roassal-Views-Tests'!

!RzVisualizer2DTest methodsFor: 'testing' stamp: ''!
tearDown
	window
		ifNotNilDo: [:t1 | t1 delete]! !

!RzVisualizer2DTest methodsFor: 'testing' stamp: ''!
testBasic
	window := RzVisualizer2D new xValues: #(1 2 3 );
				 yValues: #(1 2 3 );
				
				value: [:t1 :t2 | t1 + t2];
				 visualize! !

!RzVisualizer2DTest methodsFor: 'testing' stamp: ''!
testColor
	window := RzVisualizer2D new xValues: #(1 2 3 );
				 yValues: #(1 2 3 );
				
				value: [:t1 :t2 | t1 // t2];
				 color: Color blue;
				 visualize! !

!RzVisualizer2DTest methodsFor: 'testing' stamp: ''!
testColor2
	window := RzVisualizer2D new xValues: #(1 2 3 );
				 yValues: #(1 2 0 );
				
				value: [:t1 :t2 | [t1 / t2]
						on: Error
						do: []];
				 color: Color blue;
				 visualize! !

!RzVisualizer2DTest methodsFor: 'testing' stamp: ''!
testFactor
	window := RzVisualizer2D new xValues: #(1 2 3 );
				 yValues: #(1 2 3 );
				
				value: [:t1 :t2 | t1 // t2];
				 factor: 50;
				 visualize! !

!RzVisualizer2DTest methodsFor: 'testing' stamp: ''!
testGap
	window := RzVisualizer2D new xValues: #(1 2 3 );
				 yValues: #(1 2 3 );
				
				value: [:t1 :t2 | t1 // t2];
				 gap: 50;
				 visualize! !

!RzVisualizer2DTest methodsFor: 'testing' stamp: ''!
testLabels
	window := RzVisualizer2D new xValues: #(1 2 3 );
				 yValues: #(1 2 3 );
				
				value: [:t1 :t2 | t1 // t2];
				 padding: 100;
				
				yLabel: [:t1 | 'long long text'];
				
				xLabel: [:t1 | 'text'];
				 visualize! !

!RzVisualizer2DTest methodsFor: 'testing' stamp: ''!
testPadding
	window := RzVisualizer2D new xValues: #(1 2 3 );
				 yValues: #(1 2 3 );
				
				value: [:t1 :t2 | t1 // t2];
				 padding: 100;
				
				yLabel: [:t1 | 'long long text'];
				 visualize! !

Object subclass: #RzRect
	instanceVariableNames: 'x y width height color model last borderColor text selected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Roassal-Views'!

!RzRect methodsFor: 'comparing' stamp: ''!
= t1 
	^ model = t1 model! !

!RzRect methodsFor: 'accessing' stamp: ''!
borderColor
	^ borderColor! !

!RzRect methodsFor: 'accessing' stamp: ''!
borderColor: t1 
	borderColor := t1! !

!RzRect methodsFor: 'accessing' stamp: ''!
color
	^ color! !

!RzRect methodsFor: 'accessing' stamp: ''!
color: t1 
	color := t1! !

!RzRect methodsFor: 'accessing' stamp: ''!
hasLast
	^ last notNil! !

!RzRect methodsFor: 'accessing' stamp: ''!
height
	^ height! !

!RzRect methodsFor: 'accessing' stamp: ''!
height: t1 
	height := t1! !

!RzRect methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	text := [:t1 | t1 asString].
	x := 0.
	y := 0.
	width := 5.
	height := 5.
	model := ''.
	color := Color white.
	borderColor := Color black.
	selected := false! !

!RzRect methodsFor: 'accessing' stamp: ''!
last
	^ last! !

!RzRect methodsFor: 'accessing' stamp: ''!
last: t1 
	last := t1! !

!RzRect methodsFor: 'accessing' stamp: ''!
model
	^ model! !

!RzRect methodsFor: 'accessing' stamp: ''!
model: t1 
	model := t1! !

!RzRect methodsFor: 'accessing' stamp: ''!
printOn: t1 
	t1
		nextPutAll: (text value: model)! !

!RzRect methodsFor: 'accessing' stamp: ''!
printString
	^ text value: model! !

!RzRect methodsFor: 'accessing' stamp: ''!
selected
	^ selected! !

!RzRect methodsFor: 'accessing' stamp: ''!
selected: t1 
	selected := t1! !

!RzRect methodsFor: 'accessing' stamp: ''!
text
	^ text! !

!RzRect methodsFor: 'accessing' stamp: ''!
text: t1 
	text := t1! !

!RzRect methodsFor: 'accessing' stamp: ''!
width
	^ width! !

!RzRect methodsFor: 'accessing' stamp: ''!
width: t1 
	width := t1! !

!RzRect methodsFor: 'accessing' stamp: ''!
x
	^ x! !

!RzRect methodsFor: 'accessing' stamp: ''!
x: t1 
	x := t1! !

!RzRect methodsFor: 'accessing' stamp: ''!
y
	^ y! !

!RzRect methodsFor: 'accessing' stamp: ''!
y: t1 
	y := t1! !

Object subclass: #RzVisualizer
	instanceVariableNames: 'owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Roassal-Views'!

!RzVisualizer class methodsFor: 'factory' stamp: ''!
owner: t1 
	| t2 |
	t2 := self new.
	t2 owner: t1.
	^ t2! !

!RzVisualizer methodsFor: 'rizel' stamp: ''!
applyLayoutIn: t1 
	t1 scatterPlotLayout x: #x;
		 y: #y! !

!RzVisualizer methodsFor: 'rizel' stamp: ''!
draw: t1 in: t2 
	self
		draw: t1
		in: t2
		forIt: []! !

!RzVisualizer methodsFor: 'rizel' stamp: ''!
draw: t1 in: t2 forIt: t3 
	t2 shape rectangle width: t1 width;
		 height: t1 height;
		 fillColor: t1 color;
		 borderColor: t1 borderColor.
	t2 node: t1 forIt: t3.
	self applyLayoutIn: t2! !

!RzVisualizer methodsFor: 'rizel' stamp: ''!
drawLabel: t1 at: t2 in: t3 
	t3 label
		text: [:t4 | t1].
	t3 node: (RzRect new x: t2 x;
			 y: t2 y).
	self applyLayoutIn: t3! !

!RzVisualizer methodsFor: 'accessing' stamp: ''!
owner
	^ owner! !

!RzVisualizer methodsFor: 'accessing' stamp: ''!
owner: t1 
	owner := t1! !

!RzVisualizer methodsFor: 'visualization' stamp: ''!
visualize
	| t1 |
	t1 := ROMondrianViewBuilder new.
	self visualizeOn: t1.
	^ t1 open! !

RzVisualizer subclass: #RzVisualizer1D
	instanceVariableNames: 'label gap values padding height barWidth factor y'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Roassal-Views'!

!RzVisualizer1D methodsFor: 'accessing' stamp: ''!
barWidth: t1 
	barWidth := t1! !

!RzVisualizer1D methodsFor: 'accessing' stamp: ''!
gap: t1 
	gap := t1! !

!RzVisualizer1D methodsFor: 'accessing' stamp: ''!
height
	^ height! !

!RzVisualizer1D methodsFor: 'accessing' stamp: ''!
height: t1 
	height := t1! !

!RzVisualizer1D methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	factor := 2.
	gap := 40.
	padding := 50.
	height := 200.
	label := [:t1 | t1 printString].
	barWidth := 10.
	y := [:t1 | t1]! !

!RzVisualizer1D methodsFor: 'accessing' stamp: ''!
label: t1 
	label := t1! !

!RzVisualizer1D methodsFor: 'util' stamp: ''!
minValue: t1 in: t2 
	| t3 |
	t3 := t2 maxValue: t1.
	values
		do: [:t5 | t3 := (t1 value: t5)
						min: t3].
	^ t3! !

!RzVisualizer1D methodsFor: 'accessing' stamp: ''!
padding: t1 
	padding := t1! !

!RzVisualizer1D methodsFor: 'accessing' stamp: ''!
values: t1 
	values := t1! !

!RzVisualizer1D methodsFor: 'drawing' stamp: ''!
visualizeBarsOn: t1 
	| t2 t3 t4 t5 t6 |
	t2 := self minValue: y in: values.
	t3 := values maxValue: y.
	t4 := t3 - t2.
	t5 := t3 = t2
				ifTrue: [self height]
				ifFalse: [self height / t4].
	t6 := gap.
	values
		do: [:t8 | 
			| t9 |
			t9 := y value: t8.
			self draw: (RzRect new x: t6;
					 y: (self height - (t9 - t2 * t5)) asInteger;
					 model: t8;
					 color: Color blue;
					 width: barWidth;
					 height: (t9 - t2 * t5) asInteger) in: t1.
			self
				drawLabel: (label value: t8)
				at: t6 @ (self height + 10)
				in: t1.
			t6 := t6 + (barWidth + gap)].
	self applyLayoutIn: t1! !

!RzVisualizer1D methodsFor: 'drawing' stamp: ''!
visualizeOn: t1 
	self visualizeValuesOn: t1.
	self applyLayoutIn: t1! !

!RzVisualizer1D methodsFor: 'drawing' stamp: ''!
visualizeValuesOn: t1 
	self
		draw: (RzRect new x: padding + factor + gap;
				 y: factor + gap;
				 width: self width;
				 borderColor: Color white;
				 height: self height)
		in: t1
		forIt: [self visualizeBarsOn: t1].
	self applyLayoutIn: t1! !

!RzVisualizer1D methodsFor: 'accessing' stamp: ''!
width
	^ factor + (gap + barWidth) * values size! !

RzVisualizer subclass: #RzVisualizer2D
	instanceVariableNames: 'xValues yValues factor gap value padding xLabel yLabel color root points A B'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Roassal-Views'!

!RzVisualizer2D methodsFor: 'accessing' stamp: ''!
A
	^ A model model! !

!RzVisualizer2D methodsFor: 'accessing' stamp: ''!
B
	^ B model model! !

!RzVisualizer2D methodsFor: 'accessing' stamp: ''!
color: t1 
	color := t1! !

!RzVisualizer2D methodsFor: 'rizel' stamp: ''!
drawPoint: t1 in: t2 forIt: t3 
	t2 shape rectangle width: t1 width;
		 height: t1 height;
		 fillColor: t1 color;
		 borderWidth: 2;
		
		borderColor: [:t4 | 
			Transcript show: t4 selected;
				 cr.
			t4 selected
				ifTrue: [Color red]
				ifFalse: [t4 borderColor]].
	t2 interaction
		on: ROMouseClick
		do: [:t4 | 
			t4 element model selected: true.
			A
				ifNil: [A := t4 element]
				ifNotNil: [B
						ifNil: [B := t4 element]
						ifNotNil: [A := B.
							B := t4 element]].
			points
				do: [:t5 | (t5 getShape: ROBox)
						borderColor: Color black].
			A
				ifNotNil: [(A getShape: ROBox)
						borderColor: Color blue].
			B
				ifNotNil: [(B getShape: ROBox)
						borderColor: Color blue].
			root container
				elementsDo: [:t5 | t5 signalUpdate]].
	points
		add: (t2 node: t1 forIt: t3).
	self applyLayoutIn: t2! !

!RzVisualizer2D methodsFor: 'accessing' stamp: ''!
factor: t1 
	factor := t1! !

!RzVisualizer2D methodsFor: 'accessing' stamp: ''!
gap: t1 
	gap := t1! !

!RzVisualizer2D methodsFor: 'accessing' stamp: ''!
height
	^ yValues size * (factor + gap)! !

!RzVisualizer2D methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	gap := 20.
	factor := 25.
	xValues := OrderedCollection new.
	yValues := OrderedCollection new.
	padding := 50.
	color := Color red.
	xLabel := [:t1 | t1 printString].
	yLabel := [:t1 | t1 printString].
	points := OrderedCollection new! !

!RzVisualizer2D methodsFor: 'util' stamp: ''!
max
	| t1 |
	t1 := 0.
	xValues
		do: [:t3 | yValues
				do: [:t4 | (value value: t3 value: t4)
						ifNotNilDo: [:t5 | t1 := t5 max: t1]]].
	^ t1! !

!RzVisualizer2D methodsFor: 'accessing' stamp: ''!
padding: t1 
	padding := t1! !

!RzVisualizer2D methodsFor: 'accessing' stamp: ''!
value: t1 
	value := t1! !

!RzVisualizer2D methodsFor: 'roassal' stamp: ''!
visualizeOn: t1 
	root := t1.
	self
		draw: (RzRect new x: padding + gap;
				 y: gap;
				 borderColor: Color white;
				 width: self height + gap;
				 height: self width + padding + gap)
		in: t1
		forIt: [self visualizeXAxisOn: t1.
			self visualizeYAxisOn: t1.
			self visualizeValuesOn: t1.
			self applyLayoutIn: t1]! !

!RzVisualizer2D methodsFor: 'roassal' stamp: ''!
visualizePointsOn: t1 
	| t2 t3 t5 |
	t2 := Color white mix: color shades: 101.
	t5 := gap // 2.
	yValues
		do: [:t6 | 
			| t7 |
			t7 := ((xValues
						collect: [:t8 | value value: t8 value: t6])
						select: [:t8 | t8 notNil])
						maxValue: #yourself.
			t7 := t7 isZero
						ifTrue: [1]
						ifFalse: [t7].
			t3 := gap // 2.
			xValues
				do: [:t8 | 
					| t9 t10 |
					t9 := value value: t8 value: t6.
					t10 := t9
								ifNil: [Color gray]
								ifNotNil: [t2 at: (t9 * 100 / t7 + 1) asInteger].
					self
						drawPoint: (RzRect new x: t3;
								 y: t5;
								 model: RzVector <== t8 + t6;
								 color: t10;
								 width: factor;
								 height: factor)
						in: t1
						forIt: [].
					t3 := t3 + factor + gap].
			t5 := t5 + factor + gap]! !

!RzVisualizer2D methodsFor: 'roassal' stamp: ''!
visualizeValuesOn: t1 
	self
		draw: (RzRect new x: padding + gap;
				 y: gap;
				 borderColor: Color white;
				 width: self width;
				 height: self height)
		in: t1
		forIt: [self visualizePointsOn: t1]! !

!RzVisualizer2D methodsFor: 'roassal' stamp: ''!
visualizeXAxisOn: t1 
	| t2 t3 |
	t3 := padding + gap + (gap // 2).
	t2 := gap + self height + (gap // 2).
	xValues
		do: [:t5 | 
			self
				drawLabel: (xLabel value: t5)
				at: t3 @ t2
				in: t1.
			t3 := t3 + (factor + gap)].
	self applyLayoutIn: t1! !

!RzVisualizer2D methodsFor: 'roassal' stamp: ''!
visualizeYAxisOn: t1 
	| t2 t3 |
	t2 := gap.
	t3 := gap + (gap // 2).
	yValues
		do: [:t5 | 
			self
				drawLabel: (yLabel value: t5)
				at: t2 @ t3
				in: t1.
			t3 := t3 + (factor + gap)]! !

!RzVisualizer2D methodsFor: 'accessing' stamp: ''!
width
	^ xValues size * (factor + gap)! !

!RzVisualizer2D methodsFor: 'accessing' stamp: ''!
xLabel: t1 
	xLabel := t1! !

!RzVisualizer2D methodsFor: 'accessing' stamp: ''!
xValues: t1 
	xValues := t1! !

!RzVisualizer2D methodsFor: 'accessing' stamp: ''!
yLabel: t1 
	yLabel := t1! !

!RzVisualizer2D methodsFor: 'accessing' stamp: ''!
yValues: t1 
	yValues := t1! !

RzVisualizer subclass: #RzVisualizerMerge
	instanceVariableNames: 'profile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Roassal-Views'!

!RzVisualizerMerge class methodsFor: 'factory' stamp: ''!
on: t1 
	| t2 |
	t2 := self new.
	t2 profile: t1.
	^ t2! !

!RzVisualizerMerge methodsFor: 'metrics' stamp: ''!
borderColorForMethod: t1 
	t1 hasDifferentByteCode
		ifTrue: [^ Color red].
	^ Color gray! !

!RzVisualizerMerge methodsFor: 'morph' stamp: ''!
browseMethod: t1 
	| t2 t3 |
	t2 := t1
				property: #copySourceCode
				from: #old
				ifAbsent: [''].
	t3 := t1
				property: #copySourceCode
				from: #new
				ifAbsent: [''].
	((DiffMorph from: t2 to: t3)
		extent: 200 @ 200) newWindow open! !

!RzVisualizerMerge methodsFor: 'metrics' stamp: ''!
colorForMethod: t1 
	| t2 t3 |
	t2 := t1
				property: #executionTime
				from: #old
				ifAbsent: [0].
	t3 := t1
				property: #executionTime
				from: #new
				ifAbsent: [0].
	t1 wasDeleted
		ifTrue: [^ Color gray].
	t1 isNew
		ifTrue: [^ Color yellow].
	t3 > t2
		ifTrue: [^ Color red].
	t3 < t2
		ifTrue: [^ Color green].
	^ Color white! !

!RzVisualizerMerge methodsFor: 'metrics' stamp: ''!
heightForMethod: t1 
	| t2 t3 |
	t2 := t1
				property: #executionTime
				from: #old
				ifAbsent: [0].
	t3 := t1
				property: #executionTime
				from: #new
				ifAbsent: [0].
	Transcript show: t2 asString , ' - ' , t3 asString;
		 cr.
	^ (t3 > t2
		ifTrue: [t3 - t2]
		ifFalse: [0])
		+ 5! !

!RzVisualizerMerge methodsFor: 'accessing' stamp: ''!
profile
	^ profile! !

!RzVisualizerMerge methodsFor: 'accessing' stamp: ''!
profile: t1 
	profile := t1! !

!RzVisualizerMerge methodsFor: 'roassal' stamp: ''!
visualizeClasses: t1 in: t2 
	t2 shape rectangle withoutBorder.
	t2
		nodes: (t1 classes
				select: [:t3 | ('* class' match: t3 className) not])
		forEach: [:t3 | 
			t2
				node: 'methods'
				forIt: [self visualizeMethods: t3 in: t2].
			t2 shape label.
			t2 node: t3 className.
			t2 verticalLineLayout].
	t2 horizontalLineLayout! !

!RzVisualizerMerge methodsFor: 'roassal' stamp: ''!
visualizeMethods: t1 in: t2 
	t2 shape rectangle
		width: [:t3 | self widthForMethod: t3];
		
		height: [:t3 | self heightForMethod: t3];
		
		color: [:t3 | self colorForMethod: t3];
		
		borderColor: [:t3 | self borderColorForMethod: t3].
	t2 interaction
		item: 'browse code'
		action: [:t3 | self browseMethod: t3].
	t2 nodes: t1 allMethods.
	t2
		edges: t1 allMethods
		from: #yourself
		toAll: [:t3 | t3 callingMethods].
	t2 treeLayout! !

!RzVisualizerMerge methodsFor: 'roassal' stamp: ''!
visualizeOn: t1 
	self visualizeMethods: profile in: t1! !

!RzVisualizerMerge methodsFor: 'metrics' stamp: ''!
widthForMethod: t1 
	| t2 t3 |
	t2 := t1
				property: #numberOfExecutions
				from: #old
				ifAbsent: [0].
	t3 := t1
				property: #numberOfExecutions
				from: #new
				ifAbsent: [0].
	^ (t3 > t2
		ifTrue: [t3 - t2]
		ifFalse: [0])
		+ 5! !

Object subclass: #RzVisualizerSelector
	instanceVariableNames: 'owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Roassal-Views'!

!RzVisualizerSelector class methodsFor: 'as yet unclassified' stamp: ''!
owner: t1 
	| t2 |
	t2 := self new.
	t2 owner: t1.
	^ t2! !

!RzVisualizerSelector methodsFor: 'as yet unclassified' stamp: ''!
owner
	^ owner! !

!RzVisualizerSelector methodsFor: 'as yet unclassified' stamp: ''!
owner: t1 
	owner := t1! !

!RzVisualizerSelector methodsFor: 'as yet unclassified' stamp: ''!
v1D
	| t1 |
	t1 := RzVisualizer1D owner: owner.
	owner visualizer: t1.
	^ t1! !

!RzVisualizerSelector methodsFor: 'as yet unclassified' stamp: ''!
v2D
	| t1 |
	t1 := RzVisualizer2D owner: owner.
	owner visualizer: t1.
	^ t1! !
